<template>
  <main>
    <div class="row mt-4">
      <div class="col-lg-8">
        <h2
          class="sr-only"
          v-html="$t('what.title')"
        ></h2>
        <figure
          aria-hidden="true"
          class="figure text-center"
        >
          <img
            :src="`${$t('/')}img/${$t('lang')}/screenshot.gif`"
            alt=""
            class="ombre"
          />
          <figcaption
            class="figure-caption"
            v-html="$t('what.caption')"
          ></figcaption>
        </figure>
      </div>
      <div
        id="howitworks"
        class="col-lg-4"
      >
        <div v-html="$t('what.md')"></div>

        <div v-if="instance">
          <p class="text-center my-3">
            <b-button-group>
              <b-button
                variant="primary d-flex align-items-center"
                size="lg"
                :href="instance.endpoint"
              >
                <svg-icon
                  name="paper-plane"
                  variant="pr-3"
                  size="lg"
                />
                <span v-html="$t('public.create', { name: instance.title })"></span>
              </b-button>
              <b-button
                variant="primary"
                @click="anotherInstance()"
              >
                <span
                  class="position-absolute"
                  style="top: 0.125rem; right: 0.375rem"
                >
                  <svg-icon
                    name="sync-alt"
                    sr-only
                    :label="$t('public.change')"
                  />
                </span>
              </b-button>
            </b-button-group>
          </p>
          <p v-if="instance && !instance.endpoint.includes('framadrop')">
            <span
              v-if="instance"
              v-html="$t('public.external', {
                title: instance.title,
                website: instance.website
              })"
            ></span>
            <span
              v-if="instance && instance.chatons"
              v-html="$t('public.chatons')"
            ></span>.
          </p>
          <p
            v-else-if="instance"
            id="frama_other_message"
            v-html="$t('public.frama_other')"
          ></p>
          <p>
            <router-link
              :to="`/${$t('lang')}/info`"
              class=""
              v-html="$t('public.full_list', { nbinstances: nbInstances })"
            />
          </p>
        </div>
      </div>
    </div>

    <hr role="presentation" />

    <div class="row mt-4">
      <!-- Help -->
      <div class="col-md-4">
        <h2 v-html="$t('help.title')"></h2>
        <svg-icon
          name="question-circle"
          size="3x"
          variant="fc-g7 d-block text-center mb-3"
        />
        <div v-html="$t('help.md')"></div>
      </div>

      <!-- About software -->
      <div class="col-md-4">
        <h2 v-html="$t('software.title')"></h2>
        <svg-icon
          name="cloud"
          size="3x"
          variant="fc-g7 d-block text-center mb-3"
        />
        <div v-html="$t('software.md')"></div>
      </div>

      <!-- Garden -->
      <div class="col-md-4">
        <h2 v-html="$t('garden.title')"></h2>
        <svg-icon
          name="leaf"
          size="3x"
          variant="fc-g7 d-block text-center mb-3"
        />
        <div v-html="$t('garden.md')"></div>
        <b-button
          variant="outline-success"
          :href="`${$t('link.cloud')}/${$t('cloud.drop')}`"
        >
          <svg-icon
            name="leaf"
            label="framacloud.org"
          />
        </b-button>
      </div>
    </div>
  </main>
</template>

<script>
import instanceStatus from '../../mixins/instanceStatus';

const DEFAULT_WEIGHT = 2;

export default {
  mixins: [instanceStatus],
  data() {
    return {
      status: {},
      instance: this.$t('instances.framadrop'),
      instances: this.$t('instances'),
    };
  },
  computed: {
    nbInstances() {
      return Object.keys(this.instances).length;
    },
  },
  async mounted() {
    this.status = await (await fetch('https://covid19.framadrop.org/instances_check.json')).json();
    this.anotherInstance();
    while (this.keyForEndpoint(this.instance.endpoint) in this.status.failed) {
      this.anotherInstance();
    }
  },
  methods: {
    create(event) {
      event.preventDefault();
      window.location = this.instance;
    },
    randomInstance() {
      const remoteInstancesSelected = Object.entries(this.instances)
        .filter(([, value]) => (!(value.trust === false)))
        .map(([key, instance]) => [key, (instance.weight || DEFAULT_WEIGHT)]);
      return this.instances[this.weightedRand(remoteInstancesSelected)];
    },
    weightedRand(data) {
      // First, we loop the main dataset to count up the total weight.
      // We're starting the counter at one because the upper boundary of Math.random() is exclusive.
      let total = 1;
      for (let i = 0; i < data.length; i += 1) {
        total += data[i][1];
      }
      // Total in hand, we can now pick a random value akin to our
      // random index from before.
      const threshold = Math.floor(Math.random() * total);

      // Now we just need to loop through the main data one more time
      // until we discover which value would live within this
      // particular threshold. We need to keep a running count of
      // weights as we go, so let's just reuse the "total" variable
      // since it was already declared.
      total = 0;
      for (let i = 0; i < data.length; i += 1) {
        // Add the weight to our running total.
        total += data[i][1];

        // If this value falls within the threshold, we're done!
        if (total >= threshold) {
          return data[i][0];
        }
      }
      // Should never happen
      return data[0][0];
    },
    anotherInstance() {
      let newInstance = this.instance;
      while (newInstance === this.instance) {
        newInstance = this.randomInstance();
      }
      this.instance = newInstance;
    },
  },
};
</script>
